local ICdt = 0
local menuimputtext = ""
local ICdysplay = ""
local ICtitletext = ""
local ICnterval = 0.5
local ICstate = false
local shiftstate = false
local iskeytab = {}
local ismorespectab = {}
local returnfunction = {}
local minL, maxL = 1,14

local specialrkeytab = {
	lshift = function()
		shiftstate = false
	end,
	rshift = function()
		shiftstate = false
	end,
}

local enterspecial = function()
	local l = string.len(menuimputtext or "")
		
	if l < minL then
				
	else
		returnfunction(menuimputtext)	
	end
end

local specialkeytab = {
	backspace = function()
		local l = string.len(menuimputtext or "")
		if l > 0 then
			menuimputtext = string.sub(menuimputtext,0,l-1)
		end
	end,
	lshift = function()
		shiftstate = true
	end,
	rshift = function()
		shiftstate = true
	end,
	["kpenter"] = function()
		enterspecial()
	end,
	["return"] = function()
		enterspecial()
	end
}

local typenamefunc = function(key)
	if ismorespectab[key] then key = ismorespectab[key] end
	local l = string.len(menuimputtext or "")
	if l < maxL then
		if shiftstate then key = string.upper(key) end
		menuimputtext = (menuimputtext or "")..key
	end

end



return {
	setup = function(retfunc,keytab,morespecialkeytab,title,mint,maxt)
		menuimputtext = ""
		returnfunction = retfunc
		ismorespectab = morespecialkeytab
		ICtitletext = title
		minL, maxL = mint,maxt
		for i,key in pairs (keytab) do
			iskeytab[key] = true
		end
	end,
	update = function(dt)
		ICdt = ICdt + dt
		if ICdt > ICnterval then
			ICdt = 0
			ICstate = not ICstate
			if ICstate then
				ICdysplay = ""
			else
				ICdysplay = "|"
			end
		end	
	end,
	draw = function(screen)
		love.graphics.setColor( 0, 255, 255)
		love.graphics.rectangle("fill", screen.h_w -  4 * 32,48, 8*32,32)
		local pair = false
		love.graphics.setColor( 0, 0, 0)
		love.graphics.print(ICtitletext, screen.h_w -  3 * 32, 2*32)
		love.graphics.setColor( 150, 150, 150)
		love.graphics.rectangle("fill",screen.h_w -  4 * 32, 48+32,8 * 32, 32)
		love.graphics.setColor( 0, 0, 0)
		love.graphics.print(menuimputtext..ICdysplay, screen.h_w -  3 * 32, 2 * 32 +22)
	end,
	key = function(key)
		if specialkeytab[key] then specialkeytab[key]()
		elseif iskeytab[key] then typenamefunc(key) end
	end,
	keyr = function(key)
		if specialrkeytab[key] then specialrkeytab[key]() end
	end
}



