return {
	load = function(mapfile)
		local path = "data/levels/"
		if not mapfile or not love.filesystem.exists(path..mapfile) then
			mapfile = "map0.txt"
		end
		local ok,map = true,love.filesystem.load(path..mapfile)
		ok,map = pcall(map)
		if not ok then
			map = filesystem.load(path.."map0.txt")
			map = map()
		end
		local static_spawn = {}
		for y=1,#map do
			for x=1,#map[1] do
				if map[y][x].col == 10 then
					static_spawn[#static_spawn+1]={x=x,y=y}
				end
			end
		end
		dynamicmap = {}
		prevdynamicmap = {}
		return{map=map,dynamicmap=dynamicmap,prevdynamicmap=prevdynamicmap,static_spawn=static_spawn}
	end
}